(defun c:k_n018	(/	     ABWAHL_LIST ART	     ATT_DATA
		 AUSWAHL_LIST		 BLUE	     BOOKNAME
		 COLOR	     COLORNAME	 DATA	     DATA_LIST1
		 DATA_LIST2  DUMMY	 DUMMY_LIST  ENT_DATA
		 ENT_NAME    FARBFILTER	 FARBNUMMER  GREEN
		 LINIENTYP   N		 N018_ID     NR
		 OBJ_ART     OK		 RED	     WERT
		)
;;;  Objektfilter
  (defun end_n018 (wert)
    (setq ok wert)
    (done_dialog)
  )

  (defun n018_raus ()
    (setq nr (atoi (get_tile "auswahl")))
    (setq dummy_list (list))
    (setq n 0)
    (foreach
	      data
		  data_list1
      (if (/= n nr)
	(setq dummy_list (cons data dummy_list))
	(setq data_list2 (cons data data_list2))
      )
      (setq n (1+ n))
    )
    (setq data_list1 (reverse dummy_list))
    (n018_auswahl)
    (n018_abwahl)
    (if	data_list1
      (progn
	(setq nr (min nr (1- (length data_list1))))
	(set_tile "auswahl" (itoa nr))
      )
    )
  )

  (defun n018_rein ()
    (setq nr (atoi (get_tile "abwahl")))
    (setq dummy_list (list))
    (setq n 0)
    (foreach
	      data
		  data_list2
      (if (/= n nr)
	(setq dummy_list (cons data dummy_list))
	(setq data_list1 (cons data data_list1))
      )
      (setq n (1+ n))
    )
    (setq data_list2 (reverse dummy_list))
    (n018_auswahl)
    (n018_abwahl)
    (if	data_list2
      (progn
	(setq nr (min nr (1- (length data_list2))))
	(set_tile "abwahl" (itoa nr))
      )
    )
  )

  (defun n018_auswahl_s	()
    (mode_tile "rein" 1)
    (mode_tile "raus" 0)
    (if	(= $reason 4)
      (n018_raus)
    )
  )

  (defun n018_abwahl_s ()
    (mode_tile "rein" 0)
    (mode_tile "raus" 1)
    (if	(= $reason 4)
      (n018_rein)
    )
  )

  (defun n018_auswahl ()
    (setq auswahl_list (list))
    (foreach
	      data
		  (reverse data_list1)
      (setq art (nth 1 data))
      (setq wert (cdr (nth 2 data)))
      (cond
	((= (type wert) 'real)
	 (setq wert (rtos wert))
	)
	((= (type wert) 'int)
	 (setq wert (itoa wert))
	)
	((= (type wert) 'str)
	 (setq wert wert)
	)
	((= (type wert) 'list)
	 (setq dummy "")
	 (foreach
		   w
		    wert
	   (cond
	     ((= (type w) 'real)
	      (setq w (rtos w))
	     )
	     ((= (type w) 'int)
	      (setq w (itoa w))
	     )
	     ((= (type w) 'str)
	      (setq w w)
	     )
	   )
	   (setq dummy (strcat dummy "," w))
	 )
	 (setq wert (substr dummy 2))
	)
	((= (type wert) 'SYM)
	 (setq wert (vl-princ-to-string wert))
	)
      )
      (setq data (strcat art " = " wert))
      (setq auswahl_list (cons data auswahl_list))
    )
    (start_list "auswahl")
    (mapcar 'add_list auswahl_list)
    (end_list)
  )

  (defun n018_abwahl ()
    (setq abwahl_list (list))
    (foreach
	      data
		  (reverse data_list2)
      (setq art (nth 1 data))
      (setq wert (cdr (nth 2 data)))
      (cond
	((= (type wert) 'real)
	 (setq wert (rtos wert))
	)
	((= (type wert) 'int)
	 (setq wert (itoa wert))
	)
	((= (type wert) 'str)
	 (setq wert wert)
	)
	((= (type wert) 'list)
	 (setq dummy "")
	 (foreach
		   w
		    wert
	   (cond
	     ((= (type w) 'real)
	      (setq w (rtos w))
	     )
	     ((= (type w) 'int)
	      (setq w (itoa w))
	     )
	     ((= (type w) 'str)
	      (setq w w)
	     )
	   )
	   (setq dummy (strcat dummy "," w))
	 )
	 (setq wert (substr dummy 2))
	)
	((= (type wert) 'SYM)
	 (setq wert (vl-princ-to-string wert))
	)
      )
      (setq data (strcat art " = " wert))
      (setq abwahl_list (cons data abwahl_list))
    )
    (start_list "abwahl")
    (mapcar 'add_list abwahl_list)
    (end_list)
  )

  (defun k_n018_dialog ()
    (setq ent_data (entget ent_name))
    (setq obj_art (cdr (assoc 0 ent_data)))
    (setq data_list1 (list))

    (setq red	(vla-get-red
		  (vla-get-truecolor (vlax-ename->vla-object ent_name))
		)
	  green	(vla-get-green
		  (vla-get-truecolor (vlax-ename->vla-object ent_name))
		)
	  blue	(vla-get-blue
		  (vla-get-truecolor (vlax-ename->vla-object ent_name))
		)
    )

    (if	(assoc 420 ent_data)
      (progn
	(setq
	  farbnummer (cdr (assoc 420 ent_data))
	  bookname   (vla-get-bookname
		       (vla-get-truecolor
			 (vlax-ename->vla-object ent_name)
		       )
		     )
	  colorname  (vla-get-colorname
		       (vla-get-truecolor
			 (vlax-ename->vla-object ent_name)
		       )
		     )
	)
	(if (= bookname "")
	  (setq	color
		 (cons
		   6
		   (strcat
		     "RGB:"
		     (itoa
		       (vla-get-red
			 (vla-get-truecolor (vlax-ename->vla-object ent_name))
		       )
		     )
		     ","
		     (itoa
		       (vla-get-green
			 (vla-get-truecolor (vlax-ename->vla-object ent_name))
		       )
		     )
		     ","
		     (itoa
		       (vla-get-blue
			 (vla-get-truecolor (vlax-ename->vla-object ent_name))
		       )
		     )
		   )
		 )
	  )
	  (setq	color
		 (cons
		   6
		   (strcat
		     (vla-get-bookname
		       (vla-get-truecolor (vlax-ename->vla-object ent_name))
		     )
		     "$"
		     (vla-get-colorname
		       (vla-get-truecolor (vlax-ename->vla-object ent_name))
		     )
		   )
		 )
	  )
	)
	(setq farbfilter (list (assoc 420 ent_data)))
      )
      (progn
	(if (assoc 62 ent_data)
	  (setq color (assoc 62 ent_data))
	  (setq color (cons 62 256))
	)
	(setq farbfilter (list color))
      )
    )

    (if	(assoc 6 ent_data)
      (setq linientyp (assoc 6 ent_data))
      (setq linientyp (cons 6 "vonlayer"))
    )
    (setq data_list1 (list))
    (setq data_list2
	   (mapcar '(lambda (att_data)
		      (list -66 (nth 0 att_data) (cons 1 (nth 1 att_data)))
		    )
		   (k_get_data
		     ent_name
		     "*"
		     (k_get_ini "Applikationsname" nil)
		     nil
		   )
	   )
    )
    (setq data_list2
	   (append
	     (list
	       (list
		 "vla"
		 "Rotwert"
		 (cons
		   "(vla-get-red (vla-get-truecolor (vlax-ename->vla-object ent_name)))"
		   (vla-get-red
		     (vla-get-truecolor
		       (vlax-ename->vla-object ent_name)
		     )
		   )
		 )
	       )
	       (list
		 "vla"
		 "Grnwert"
		 (cons
		   "(vla-get-green (vla-get-truecolor (vlax-ename->vla-object ent_name)))"
		   (vla-get-green
		     (vla-get-truecolor
		       (vlax-ename->vla-object ent_name)
		     )
		   )
		 )
	       )
	       (list
		 "vla"
		 "Blauwert"
		 (cons
		   "(vla-get-blue (vla-get-truecolor (vlax-ename->vla-object ent_name)))"
		   (vla-get-blue
		     (vla-get-truecolor
		       (vlax-ename->vla-object ent_name)
		     )
		   )
		 )
	       )
	       (list
		 "vla"
		 "Farbbuchname"
		 (cons
		   "(vla-get-bookname (vla-get-truecolor (vlax-ename->vla-object ent_name)))"
		   (vla-get-bookname
		     (vla-get-truecolor
		       (vlax-ename->vla-object ent_name)
		     )
		   )
		 )
	       )
	       (list
		 "vla"
		 "Farbname"
		 (cons
		   "(vla-get-colorname (vla-get-truecolor (vlax-ename->vla-object ent_name)))"
		   (vla-get-colorname
		     (vla-get-truecolor
		       (vlax-ename->vla-object ent_name)
		     )
		   )
		 )
	       )
	     )
	     data_list2
	   )
    )

    (cond
      ((= obj_art "3DFACE")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "3DSOLID")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
      )
      ((= obj_art "ACAD_PROXY_ENTITY")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
	      )
       )
      )
      ((= obj_art "ACAD_TABLE")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list
		      "vla"
		      "Stilname"
		      (cons
			"(vla-get-StyleName (vlax-ename->vla-object ent_name))"
			(vla-get-stylename (vlax-ename->vla-object ent_name))
		      )
		    )
	      )
       )
      )
      ((= (substr obj_art 1 3) "AEC")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
	      )
       )
      )
      ((= obj_art "ARC")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
		    (list 40 "Radius" (assoc 40 ent_data))
	      )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "ATTDEF")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
		    (list 7 "Stilname" (assoc 7 ent_data))
	      )
       )
       (setq data_list2
	      (append
		(list (list 2 "Bezeichnung" (assoc 2 ent_data))
		      (list 3 "Eingabe" (assoc 3 ent_data))
		      (list 40 "Texthhe" (assoc 40 ent_data))
		)
		data_list2
	      )
       )
      )
      ((= obj_art "ATTRIB")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
      )
      ((= obj_art "CIRCLE")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
		    (list 40 "Radius" (assoc 40 ent_data))
	      )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "DIMENSION")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
		    (list 3 "Bemaungsstil" (assoc 3 ent_data))
	      )
       )
       (setq data_list2
	      (append
		(list
		  (list
		    "vla"
		    "Bemaungsart"
		    (cons
		      "(vla-get-ObjectName (vlax-ename->vla-object ent_name))"
		      (vla-get-ObjectName
			(vlax-ename->vla-object ent_name)
		      )
		    )
		  )
		)
		data_list2
	      )
       )

       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "ELLIPSE")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "HATCH")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
		    (list 2 "Schraffurmuster" (assoc 2 ent_data))
	      )
       )
       (if (assoc 41 ent_data)
	 (setq data_list1
		(reverse
		  (cons	(list 41 "Skalierung" (assoc 41 ent_data))
			(reverse data_list1)
		  )
		)
	 )
       )
       (if (assoc 52 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 52 "Schraffurwinkel" (assoc 52 ent_data))
		  )
		  data_list2
		)
	 )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "IMAGE")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
	      )
       )
      )
      ((= obj_art "INSERT")
       (setq data_list1
	      (list
		(list 0 "Objektart" (assoc 0 ent_data))
		(list 8 "Layer" (assoc 8 ent_data))
		(list 62 "Farbe" color)
		(list
		  "vla"
		  "Originalname"
		  (cons
		    "(vla-get-EffectiveName (vlax-ename->vla-object ent_name))"
		    (vla-get-effectivename (vlax-ename->vla-object ent_name))
		  )
		)
		(list
		  "vla"
		  "Dynamisch"
		  (cons
		    "(vla-get-IsDynamicBlock (vlax-ename->vla-object ent_name))"
		    (vla-get-IsDynamicBlock (vlax-ename->vla-object ent_name))
		  )
		)
	      )
       )
       (setq data_list2
	      (append
		(list (list 2 "Blockname" (assoc 2 ent_data))
		      (list 6 "Linientyp" linientyp)
		      (list 41 "X-Skalierfaktor" (assoc 41 ent_data))
		      (list 42 "Y-Skalierfaktor" (assoc 42 ent_data))
		      (list 43 "Z-Skalierfaktor" (assoc 43 ent_data))
		      (list 66 "Attribute vorhanden" (cons 66 1))
		      (list 50 "Drehwinkel" (assoc 50 ent_data))
		)
		data_list2
	      )
       )
      )
      ((= obj_art "LEADER")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 3 "Bemaungsstil" (assoc 3 ent_data))
	      )
       )
       (setq data_list2
	      (append
		(list (list 6 "Linientyp" linientyp))
		data_list2
	      )
       )
      )
      ((= obj_art "LINE")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
       (setq data_list2
	      (append
		(list
		  (list
		    "vla"
		    "Lnge"
		    (cons
		      "(vla-get-length (vlax-ename->vla-object ent_name))"
		      (vla-get-length (vlax-ename->vla-object ent_name))
		    )
		  )
		)
		data_list2
	      )
       )
      )
      ((= obj_art "LWPOLYLINE")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
       (setq data_list2
	      (append
		(list
		  (list
		    "vla"
		    "Geschlossen"
		    (cons
		      "(vla-get-closed (vlax-ename->vla-object ent_name))"
		      (vla-get-closed (vlax-ename->vla-object ent_name))
		    )
		  )
		)
		data_list2
	      )
       )
       (if (assoc 43 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 43 "Globale Breite" (assoc 43 ent_data))
		  )
		  data_list2
		)
	 )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "MLINE")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
		    (list 2 "Stilname" (assoc 2 ent_data))
	      )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "MTEXT")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 7 "Stilname" (assoc 7 ent_data))
	      )
       )
       (setq data_list2
	      (append
		(list (list 1 "Textinhalt" (assoc 1 ent_data))
		      (list 6 "Linientyp" linientyp)
		      (list 40 "Texthhe" (assoc 40 ent_data))
		      (list 50 "Drehung" (assoc 50 ent_data))
		      (list 210 "Ausrichtung" (assoc 210 ent_data))
		)
		data_list2
	      )
       )
      )
      ((= obj_art "OLEFRAME")
      )
      ((= obj_art "OLE2FRAME")
      )
      ((= obj_art "POINT")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
      )
      ((= obj_art "POLYLINE")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "RAY")
      )
      ((= obj_art "REGION")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "SEQEND")
      )
      ((= obj_art "SOLID")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
	      )
       )
      )
      ((= obj_art "SYMBOL")
      )
      ((= obj_art "SPLINE")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "TEXT")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 7 "Stilname" (assoc 7 ent_data))
	      )
       )
       (setq data_list2
	      (append
		(list (list 1 "Textinhalt" (assoc 1 ent_data))
		      (list 6 "Linientyp" linientyp)
		      (list 40 "Texthhe" (assoc 40 ent_data))
		      (list 50 "Drehung" (assoc 50 ent_data))
		      (list 210 "Ausrichtung" (assoc 210 ent_data))
		)
		data_list2
	      )
       )
       (if (assoc 41 ent_data)
	 (setq data_list2
		(append
		  data_list2
		  (list
		    (list 41 "Breitenfaktor" (assoc 41 ent_data))
		  )
		)
	 )
	 (setq data_list2
		(append	data_list2
			(list
			  (list 41 "Breitenfaktor" (cons 41 1.0))
			)
		)
	 )
       )
      )
      ((= obj_art "TRACE")
      )
      ((= obj_art "VIEWPORT")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
		    (list 410 "Layout" (assoc 410 ent_data))
	      )
       )
       (setq data_list2
	      (append data_list2
		      (list
			(list 68 "Aktiv" (assoc 68 ent_data))
		      )
	      )
       )
      )
      ((= obj_art "WIPEOUT")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
      )
      ((= obj_art "XLINE")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "MANSFEN")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
       (if (assoc 48 ent_data)
	 (setq data_list2
		(append
		  (list
		    (list 48 "Objektlinientypskalierung" (assoc 48 ent_data))
		  )
		  data_list2
		)
	 )
       )
      )
      ((= obj_art "ACAD_PROXY_ELEMENT")
       (setq data_list1
	      (list (list 0 "Objektart" (assoc 0 ent_data))
		    (list 8 "Layer" (assoc 8 ent_data))
		    (list 62 "Farbe" color)
		    (list 6 "Linientyp" linientyp)
	      )
       )
      )
    )


    (print data_list1)
    (print data_list2)







    (setq n018_id (load_dialog "k_func.dcl"))
    (if	(not (new_dialog "k_n018" n018_id))
      (exit)
    )
    (n018_auswahl)
    (n018_abwahl)
    (action_tile "auswahl" "(n018_auswahl_s)")
    (action_tile "abwahl" "(n018_abwahl_s)")
    (action_tile "raus" "(n018_raus)")
    (action_tile "rein" "(n018_rein)")
    (action_tile "accept" "(end_n018 1)")
    (action_tile "cancel" "(end_n018 0)")
    (set_tile "auswahl" "0")
    (n018_auswahl_s)
    (start_dialog)
    (unload_dialog n018_id)
  )

  (print)
  (if (setq ent_name
	     (car
	       (entsel "Objekt whlen oder ENTER fr letzten Filter")
	     )
      )
    (k_n018_dialog)
    (setq data_list1
	   (k_get_hauptliste "k_n018_data")
	  farbfilter
	   (k_get_hauptliste "k_n018_color")
	  ok 1
    )
  )

  (if (= ok 1)
    (progn
      (k_put_hauptliste "k_n018_data" data_list1)
      (k_put_hauptliste "k_n018_color" farbfilter)
      (setq filter
	     (mapcar '(lambda (data) (nth 2 data))
		     (vl-remove-if
		       '(lambda	(data)
			  (or (= (car data) "vla")
			      (= (car data) -66)
			      (= (car data) 62)
			  )
			)
		       data_list1
		     )
	     )
      )

      (if (assoc 62 data_list1)
	(setq filter (append filter farbfilter))
      )

;;;      (print filter)
;;;      (princ)

      (print "bei ENTER werden alle Objekte gewhlt")
      (if (null (setq satz (ssget filter)))
	(setq satz (ssget "x" filter))
      )
      (setq ent_list (k_satz->entlist satz))

      (if (assoc 62 data_list1)
	(if (= (caar farbfilter) 62)
	  (setq	ent_list
		 (vl-remove-if
		   '(lambda (ent_name)
		      (assoc 420 (entget ent_name))
		    )
		   ent_list
		 )
	  )
	  (setq	ent_list
		 (vl-remove-if-not
		   '(lambda (ent_name)
		      (and
			(= bookname
			   (vla-get-bookname
			     (vla-get-truecolor
			       (vlax-ename->vla-object ent_name)
			     )
			   )
			)
			(= colorname
			   (vla-get-colorname
			     (vla-get-truecolor
			       (vlax-ename->vla-object ent_name)
			     )
			   )
			)
			(= red
			   (vla-get-red
			     (vla-get-truecolor
			       (vlax-ename->vla-object ent_name)
			     )
			   )
			)
			(= green
			   (vla-get-green
			     (vla-get-truecolor
			       (vlax-ename->vla-object ent_name)
			     )
			   )
			)
			(= blue
			   (vla-get-blue
			     (vla-get-truecolor
			       (vlax-ename->vla-object ent_name)
			     )
			   )
			)
		      )
		    )
		   ent_list
		 )
	  )
	)
      )

      (setq att_filter_list
	     (mapcar '(lambda (data) (list (nth 1 data) (cdr (nth 2 data))))
		     (vl-remove-if-not
		       '(lambda (data) (= (car data) -66))
		       data_list1
		     )
	     )
      )
      (setq att_bez_list
	     (mapcar '(lambda (data) (nth 0 data))
		     att_filter_list
	     )
      )
      (setq att_inh_list
	     (mapcar '(lambda (data) (nth 1 data))
		     att_filter_list
	     )
      )
      (setq ent_list
	     (vl-remove-if-not
	       '(lambda	(ent_name)
		  (equal (mapcar 'cadr
				 (k_get_data
				   ent_name
				   att_bez_list
				   (k_get_ini "Applikationsname" nil)
				   nil
				 )
			 )
			 att_inh_list
		  )
		)
	       ent_list
	     )
      )
      (setq vla_filter_list
	     (mapcar '(lambda (data) (nth 2 data))
		     (vl-remove-if-not
		       '(lambda (data) (= (car data) "vla"))
		       data_list1
		     )
	     )
      )
      (if vla_filter_list
	(setq ent_list
	       (vl-remove-if-not
		 '(lambda (ent_name)
		    (vl-remove
		      'nil
		      (mapcar
			'(lambda (vla_filter)
			   (equal
			     (eval (read (car (nth 0 vla_filter_list)))
			     )
			     (cdr (nth 0 vla_filter_list))
			   )
			 )
			vla_filter_list
		      )
		    )
		  )
		 ent_list
	       )
	)
      )
      (k_put_hauptliste "ent_list" ent_list)
      (setq satz (k_entlist->satz ent_list))
      (command "_select" satz "")
      (sssetfirst satz satz)
    )
  )
  (princ)
)